Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/optimization.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs	(revision 7294)
@@ -4431,4 +11571,14 @@
             else
             {
+                
+                //
+                // Either problem is non-convex (increase LambdaV) or constraints are inconsistent
+                //
+                ap.assert(state.qprep.terminationtype==-3 | state.qprep.terminationtype==-5, "MinLM: unexpected completion code from QP solver");
+                if( state.qprep.terminationtype==-3 )
+                {
+                    iflag = -3;
+                    goto lbl_40;
+                }
                 bflag = false;
             }
@@ -4443,7 +11593,7 @@
                 {
                     iflag = -1;
-                    goto lbl_42;
-                }
-                goto lbl_41;
+                    goto lbl_40;
+                }
+                goto lbl_39;
             }
             
@@ -4479,16 +11629,16 @@
             state.deltaxready = true;
             v = 0.0;
-            for(i_=0; i_<=n-1;i_++)
-            {
-                v += state.deltax[i_]*state.deltax[i_];
+            for(i=0; i<=n-1; i++)
+            {
+                v = v+math.sqr(state.deltax[i]/state.s[i]);
             }
             v = Math.Sqrt(v);
             if( (double)(v)>(double)(state.epsx) )
             {
+                goto lbl_41;
+            }
+            if( state.modelage!=0 )
+            {
                 goto lbl_43;
-            }
-            if( state.modelage!=0 )
-            {
-                goto lbl_45;
             }
             
@@ -4500,5 +11650,5 @@
             if( !state.xrep )
             {
-                goto lbl_47;
+                goto lbl_45;
             }
             for(i_=0; i_<=n-1;i_++)
@@ -4513,9 +11663,9 @@
         lbl_9:
             state.xupdated = false;
-        lbl_47:
+        lbl_45:
             result = false;
             return result;
-            goto lbl_46;
-        lbl_45:
+            goto lbl_44;
+        lbl_43:
             
             //
@@ -4524,7 +11674,7 @@
             //
             iflag = -2;
-            goto lbl_42;
-        lbl_46:
-        lbl_43:
+            goto lbl_40;
+        lbl_44:
+        lbl_41:
             
             //
@@ -4549,5 +11699,5 @@
             if( !state.hasfi )
             {
-                goto lbl_49;
+                goto lbl_47;
             }
             state.needfi = true;
@@ -4571,6 +11721,6 @@
             }
             state.deltafready = true;
-            goto lbl_50;
-        lbl_49:
+            goto lbl_48;
+        lbl_47:
             state.needf = true;
             state.rstate.stage = 11;
@@ -4578,5 +11728,5 @@
         lbl_11:
             state.needf = false;
-        lbl_50:
+        lbl_48:
             state.repnfunc = state.repnfunc+1;
             if( (double)(state.f)>=(double)(state.fbase) )
@@ -4589,7 +11739,7 @@
                 {
                     iflag = -1;
-                    goto lbl_42;
-                }
-                goto lbl_41;
+                    goto lbl_40;
+                }
+                goto lbl_39;
             }
             
@@ -4598,17 +11748,23 @@
             //
             iflag = 0;
-            goto lbl_42;
-            goto lbl_41;
-        lbl_42:
+            goto lbl_40;
+            goto lbl_39;
+        lbl_40:
             state.nu = 1;
-            ap.assert(iflag>=-2 & iflag<=0, "MinLM: internal integrity check failed!");
+            ap.assert(iflag>=-3 & iflag<=0, "MinLM: internal integrity check failed!");
+            if( iflag==-3 )
+            {
+                state.repterminationtype = -3;
+                result = false;
+                return result;
+            }
             if( iflag==-2 )
             {
                 state.modelage = state.maxmodelage+1;
-                goto lbl_22;
+                goto lbl_20;
             }
             if( iflag==-1 )
             {
-                goto lbl_23;
+                goto lbl_21;
             }
             
@@ -4635,14 +11791,14 @@
             if( (double)(state.predicteddecrease)<=(double)(0) )
             {
-                goto lbl_23;
+                goto lbl_21;
             }
             v = state.actualdecrease/state.predicteddecrease;
             if( (double)(v)>=(double)(0.1) )
             {
+                goto lbl_49;
+            }
+            if( increaselambda(ref state.lambdav, ref state.nu) )
+            {
                 goto lbl_51;
-            }
-            if( increaselambda(ref state.lambdav, ref state.nu) )
-            {
-                goto lbl_53;
             }
             
@@ -4653,5 +11809,5 @@
             if( !state.xrep )
             {
-                goto lbl_55;
+                goto lbl_53;
             }
             for(i_=0; i_<=n-1;i_++)
@@ -4666,9 +11822,9 @@
         lbl_12:
             state.xupdated = false;
-        lbl_55:
+        lbl_53:
             result = false;
             return result;
-        lbl_53:
         lbl_51:
+        lbl_49:
             if( (double)(v)>(double)(0.5) )
             {
@@ -4693,5 +11849,5 @@
             if( !state.xrep )
             {
-                goto lbl_57;
+                goto lbl_55;
             }
             for(i_=0; i_<=n-1;i_++)
@@ -4705,5 +11861,5 @@
         lbl_13:
             state.xupdated = false;
-        lbl_57:
+        lbl_55:
             state.repiterationscount = state.repiterationscount+1;
             if( state.repiterationscount>=state.maxits & state.maxits>0 )
@@ -4720,9 +11876,9 @@
             if( state.repterminationtype<=0 )
             {
+                goto lbl_57;
+            }
+            if( !state.xrep )
+            {
                 goto lbl_59;
-            }
-            if( !state.xrep )
-            {
-                goto lbl_61;
             }
             
@@ -4740,114 +11896,32 @@
         lbl_14:
             state.xupdated = false;
-        lbl_61:
+        lbl_59:
             result = false;
             return result;
-        lbl_59:
+        lbl_57:
             state.modelage = state.modelage+1;
-            
-            //
-            // Additional iterations for unconstrained problems:
-            // preconditioned L-BFGS is used.
-            //
-            // NOTE: additional iterations are incompatible with secant updates
-            // because they invalidate
-            //
-            if( !((double)(state.stpmax)==(double)(0) & state.makeadditers) )
-            {
-                goto lbl_63;
-            }
-            ap.assert(state.hasg | state.m!=0, "MinLM: no grad or Jacobian for additional iterations");
-            
-            //
-            // Make preconditioned iterations
-            //
-            minlbfgs.minlbfgssetcholeskypreconditioner(state.internalstate, state.dampedmodel, true);
-            minlbfgs.minlbfgsrestartfrom(state.internalstate, state.xbase);
-        lbl_65:
-            if( !minlbfgs.minlbfgsiteration(state.internalstate) )
-            {
-                goto lbl_66;
-            }
-            if( !state.internalstate.needfg )
-            {
-                goto lbl_67;
+            goto lbl_20;
+        lbl_21:
+            
+            //
+            // Lambda is too large, we have to break iterations.
+            //
+            state.repterminationtype = 7;
+            if( !state.xrep )
+            {
+                goto lbl_61;
             }
             for(i_=0; i_<=n-1;i_++)
             {
-                state.x[i_] = state.internalstate.x[i_];
-            }
+                state.x[i_] = state.xbase[i_];
+            }
+            state.f = state.fbase;
             clearrequestfields(state);
-            if( !state.hasg )
-            {
-                goto lbl_69;
-            }
-            state.needfg = true;
+            state.xupdated = true;
             state.rstate.stage = 15;
             goto lbl_rcomm;
         lbl_15:
-            state.needfg = false;
-            state.repngrad = state.repngrad+1;
-            for(i_=0; i_<=n-1;i_++)
-            {
-                state.internalstate.g[i_] = state.g[i_];
-            }
-            state.internalstate.f = state.f;
-            goto lbl_70;
-        lbl_69:
-            state.needfij = true;
-            state.rstate.stage = 16;
-            goto lbl_rcomm;
-        lbl_16:
-            state.needfij = false;
-            state.repnfunc = state.repnfunc+1;
-            state.repnjac = state.repnjac+1;
-            for(i=0; i<=n-1; i++)
-            {
-                state.internalstate.g[i] = 0;
-            }
-            for(i=0; i<=m-1; i++)
-            {
-                v = 2*state.fi[i];
-                for(i_=0; i_<=n-1;i_++)
-                {
-                    state.internalstate.g[i_] = state.internalstate.g[i_] + v*state.j[i,i_];
-                }
-                state.internalstate.f = state.internalstate.f+math.sqr(state.fi[i]);
-            }
-        lbl_70:
-        lbl_67:
-            goto lbl_65;
-        lbl_66:
-            minlbfgs.minlbfgsresultsbuf(state.internalstate, ref state.xbase, state.internalrep);
-            
-            //
-            // Invalidate DeltaX/DeltaF (control variables used for integrity checks)
-            //
-            state.deltaxready = false;
-            state.deltafready = false;
-        lbl_63:
-            goto lbl_22;
-        lbl_23:
-            
-            //
-            // Lambda is too large, we have to break iterations.
-            //
-            state.repterminationtype = 7;
-            if( !state.xrep )
-            {
-                goto lbl_71;
-            }
-            for(i_=0; i_<=n-1;i_++)
-            {
-                state.x[i_] = state.xbase[i_];
-            }
-            state.f = state.fbase;
-            clearrequestfields(state);
-            state.xupdated = true;
-            state.rstate.stage = 17;
-            goto lbl_rcomm;
-        lbl_17:
             state.xupdated = false;
-        lbl_71:
+        lbl_61:
             result = false;
             return result;
@@ -4965,4 +12039,78 @@
 
         /*************************************************************************
+        This is obsolete function.
+
+        Since ALGLIB 3.3 it is equivalent to MinLMCreateVJ().
+
+          -- ALGLIB --
+             Copyright 30.03.2009 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minlmcreatevgj(int n,
+            int m,
+            double[] x,
+            minlmstate state)
+        {
+            minlmcreatevj(n, m, x, state);
+        }
+
+
+        /*************************************************************************
+        This is obsolete function.
+
+        Since ALGLIB 3.3 it is equivalent to MinLMCreateFJ().
+
+          -- ALGLIB --
+             Copyright 30.03.2009 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minlmcreatefgj(int n,
+            int m,
+            double[] x,
+            minlmstate state)
+        {
+            minlmcreatefj(n, m, x, state);
+        }
+
+
+        /*************************************************************************
+        This function is considered obsolete since ALGLIB 3.1.0 and is present for
+        backward  compatibility  only.  We  recommend  to use MinLMCreateVJ, which
+        provides similar, but more consistent and feature-rich interface.
+
+          -- ALGLIB --
+             Copyright 30.03.2009 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minlmcreatefj(int n,
+            int m,
+            double[] x,
+            minlmstate state)
+        {
+            ap.assert(n>=1, "MinLMCreateFJ: N<1!");
+            ap.assert(m>=1, "MinLMCreateFJ: M<1!");
+            ap.assert(ap.len(x)>=n, "MinLMCreateFJ: Length(X)<N!");
+            ap.assert(apserv.isfinitevector(x, n), "MinLMCreateFJ: X contains infinite or NaN values!");
+            
+            //
+            // initialize
+            //
+            state.n = n;
+            state.m = m;
+            state.algomode = 1;
+            state.hasf = true;
+            state.hasfi = false;
+            state.hasg = false;
+            
+            //
+            // init 2
+            //
+            lmprepare(n, m, true, state);
+            minlmsetacctype(state, 0);
+            minlmsetcond(state, 0, 0, 0, 0);
+            minlmsetxrep(state, false);
+            minlmsetstpmax(state, 0);
+            minlmrestartfrom(state, x);
+        }
+
+
+        /*************************************************************************
         Prepare internal structures (except for RComm).
 
@@ -4990,7 +12138,5 @@
                 state.fibase = new double[m];
                 state.deltaf = new double[m];
-                state.fm2 = new double[m];
                 state.fm1 = new double[m];
-                state.fp2 = new double[m];
                 state.fp1 = new double[m];
             }
@@ -5002,8 +12148,8 @@
             state.deltax = new double[n];
             state.quadraticmodel = new double[n, n];
-            state.dampedmodel = new double[n, n];
             state.xbase = new double[n];
             state.gbase = new double[n];
             state.xdir = new double[n];
+            state.tmp0 = new double[n];
             
             //
@@ -5016,4 +12162,34 @@
             minlbfgs.minlbfgscreate(n, Math.Min(additers, n), state.x, state.internalstate);
             minlbfgs.minlbfgssetcond(state.internalstate, 0.0, 0.0, 0.0, Math.Min(additers, n));
+            
+            //
+            // Prepare internal QP solver
+            //
+            minqp.minqpcreate(n, state.qpstate);
+            minqp.minqpsetalgocholesky(state.qpstate);
+            
+            //
+            // Prepare boundary constraints
+            //
+            state.bndl = new double[n];
+            state.bndu = new double[n];
+            state.havebndl = new bool[n];
+            state.havebndu = new bool[n];
+            for(i=0; i<=n-1; i++)
+            {
+                state.bndl[i] = Double.NegativeInfinity;
+                state.havebndl[i] = false;
+                state.bndu[i] = Double.PositiveInfinity;
+                state.havebndu[i] = false;
+            }
+            
+            //
+            // Prepare scaling matrix
+            //
+            state.s = new double[n];
+            for(i=0; i<=n-1; i++)
+            {
+                state.s[i] = 1.0;
+            }
         }
 
